%define enginever 4.0.6
%define filtersver 4.0.6

Distribution:	CCux
Packager:  	Christian Metzen <metzench@ccux-linux.de>

Summary:   	Foomatic Scripts for the CUPS print server
Name:      	foomatic
Version:   	%{enginever}
Release:   	2
BuildArch:	i686
Provides:	foomatic
License: 	GNU/GPL
URL:		http://www.linuxprinting.org
Group:     	System/Configuration/Printing
# The database engine.
Source0: http://www.openprinting.org/download/foomatic/foomatic-db-engine-%{enginever}.tar.gz
# The CUPS driver and filter.
Source1: http://www.openprinting.org/download/foomatic/foomatic-filters-%{filtersver}.tar.gz
BuildRoot: 	%{_tmppath}/%{name}-buildroot

## PATCHES FOR FOOMATIC-FILTERS (PATCHES 1 TO 100)
# Use libdir.
Patch1: foomatic-filters-libdir.patch
# Use mkstemp, not mktemp.
Patch2: foomatic-mkstemp.patch
## PATCHES FOR FOOMATIC-DB-ENGINE (PATCHES 101 TO 200)
# Use libdir.
Patch101: foomatic-db-engine-libdir.patch
# Handle non-UTF-8 encodings in imported PPD files.
Patch102: foomatic-bad-utf8.patch

Requires:       ghostscript a2ps enscript


BuildRequires:  ghostscript-devel
BuildRequires:  a2ps-devel 
BuildRequires:  enscript
BuildRequires:  zlib-devel
BuildRequires:  perl >= 3:5.8.1
BuildRequires:  libxml2-devel
BuildRequires:  autoconf, automake
BuildRequires:  cups

# Optional BR
BuildRequires:  wget
BuildRequires:  samba-client
BuildRequires:  netcat

%description
Foomatic is a comprehensive, spooler-independent database of printers,
printer drivers, and driver descriptions. This package contains
utilities to generate driver description files and printer queues for
CUPS, LPD, LPRng, and PDQ using the database (packaged separately).
There is also the possibility to read the PJL options out of PJL-capable
laser printers and take them into account at the driver description
file generation.

There are spooler-independent command line interfaces to manipulate
queues (foomatic-configure) and to print files/manipulate jobs
(foomatic printjob).

The site http://www.linuxprinting.org/ is based on this database.

%package filters
Summary: CUPS print filters for the foomatic package
License: GPLv2+
Group: System Environment/Libraries
Obsoletes: foomatic-filters

%description filters
CUPS print filters for the foomatic package.

%post
/bin/rm -f /var/cache/foomatic/*
exit 0

%prep
%setup -q -c -a 1

pushd foomatic-filters-%{filtersver}
%patch1 -p1 -b .libdir
%patch2 -p1 -b .mkstemp
aclocal
automake
autoconf
popd

pushd foomatic-db-engine-%{enginever}
chmod a+x mkinstalldirs
%patch101 -p1 -b .libdir
%patch102 -p1
aclocal
autoconf
popd

%build
export LIB_CUPS=/usr/lib/cups               # /usr/lib NOT libdir
export CUPS_BACKENDS=/usr/lib/cups/backend  # /usr/lib NOT libdir
export CUPS_FILTERS=/usr/lib/cups/filter    # /usr/lib NOT libdir
export CUPS_PPDS=%{_datadir}/cups/model

pushd foomatic-filters-%{filtersver}
%configure
make PREFIX=%{_prefix} CFLAGS="$RPM_OPT_FLAGS"
popd

pushd foomatic-db-engine-%{enginever}
%configure --disable-xmltest
make PREFIX=%{_prefix} CFLAGS="$RPM_OPT_FLAGS"
popd

%install
rm -rf $RPM_BUILD_ROOT

pushd foomatic-filters-%{filtersver}
mkdir -p $RPM_BUILD_ROOT/%{perl_vendorlib}
make    DESTDIR=%buildroot PREFIX=%{_prefix} \
        INSTALLSITELIB=%{perl_vendorlib} \
        INSTALLSITEARCH=%{perl_vendorarch} \
        install-main install-cups
popd

pushd foomatic-db-engine-%{enginever}
make    DESTDIR=%buildroot PREFIX=%{_prefix} \
        INSTALLSITELIB=%{perl_vendorlib} \
        INSTALLSITEARCH=%{perl_vendorarch} \
        install
popd

# Use relative, not absolute, symlink for CUPS filter and driver.
ln -sf ../../../bin/foomatic-rip %{buildroot}/usr/lib/cups/filter/foomatic-rip
ln -sf ../../../bin/foomatic-ppdfile %{buildroot}/usr/lib/cups/driver/foomatic

mkdir -p $RPM_BUILD_ROOT%{_var}/cache/foomatic

echo cups > $RPM_BUILD_ROOT%{_sysconfdir}/foomatic/defaultspooler

# Remove things we don't ship.
rm -rf  \
        $RPM_BUILD_ROOT%{_libdir}/ppr \
        $RPM_BUILD_ROOT%{_sysconfdir}/foomatic/filter.conf.sample \
        $RPM_BUILD_ROOT%{_datadir}/foomatic/templates
#$RPM_BUILD_ROOT%{_libdir}/perl5/site_perl
find $RPM_BUILD_ROOT -name .packlist | xargs rm -f


%files
%defattr(-,root,root)
%doc --parents foomatic-db-engine-%{enginever}/COPYING
%config(noreplace) %{_sysconfdir}/foomatic/defaultspooler
%{_bindir}/foomatic-combo-xml
%{_bindir}/foomatic-compiledb
%{_bindir}/foomatic-configure
%{_bindir}/foomatic-datafile
%{_bindir}/foomatic-perl-data
%{_bindir}/foomatic-ppd-options
%{_bindir}/foomatic-ppd-to-xml
%{_bindir}/foomatic-ppdfile
%{_bindir}/foomatic-printjob
%{_bindir}/foomatic-searchprinter
%{_sbindir}/*
%{perl_vendorlib}/Foomatic
/usr/lib/cups/backend/beh
/usr/lib/cups/driver/*
%{_mandir}/man1/foomatic-combo-xml.1*
%{_mandir}/man1/foomatic-compiledb.1*
%{_mandir}/man1/foomatic-configure.1*
%{_mandir}/man1/foomatic-perl-data.1*
%{_mandir}/man1/foomatic-ppd-options.1*
%{_mandir}/man1/foomatic-ppdfile.1*
%{_mandir}/man1/foomatic-printjob.1*
%{_mandir}/man8/*
%{_var}/cache/foomatic


%files filters
%defattr(-,root,root)
%{_sysconfdir}/foomatic/filter.conf*
%{_bindir}/foomatic-rip
%{_libdir}/cups/backend/beh
%{_libdir}/cups/filter/foomatic-rip
#%{_libdir}/ppr/interfaces/foomatic-rip
#%{_libdir}/ppr/lib/foomatic-rip   
%{_mandir}/man1/foomatic-rip.1.gz


%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Sat Jan 22 2011 Karsten Brockmann <arcam@ccux-linux.de> 4.0.6-2
- rebuilt against libxml2 2.7.8
* Thu Jan 13 2011 Karsten Brockmann <arcam@ccux-linux.de> 4.0.6-1
- Version update, added foomatic db engine, reorganized package
- foomatic-filters is now a subpackage of foomatic
* Tue Sep 21 2010 Karsten Brockmann <arcam@ccux-linux.de> 4.0.5-1
- Version update
* Mon Nov 30 2009 Christian Metzen <metzench@ccux-linux.de> 4.0.3-1
- Version update
* Tue Aug 11 2009 Karsten Brockmann <arcam@ccux-linux.de> 4.0.2-1
- Version update
* Thu May 19 2005 Christian Metzen <metzench@ccux-linux.de> 3.0.2-1
- Version update to 3.0.2
* Fri Jun 18 2004 Christian Metzen <metzench@ccux-linux.de> 3.0.1-1
- Initial Release
